import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvFileSource;
import org.mockito.Mock;
import org.mockito.Mockito;
import org.mockito.junit.jupiter.MockitoExtension;
import static org.hamcrest.core.Is.is;
import static org.hamcrest.core.IsEqual.equalTo;
import static org.hamcrest.core.IsNot.not;
import static org.junit.Assume.assumeThat;
import static org.junit.jupiter.api.Assertions.*;

@ExtendWith(MockitoExtension.class)
public class EmployeeTest
{
        @Mock
        Employee employee;

        @ParameterizedTest
        @CsvFileSource(resources = "/FiveEmployees.csv")
        void testMethod1(String firstName, String lastName, int age, String address1, String address2, String city, String state, int postalCode)
        {
            assumeThat(firstName, is(not(equalTo(null))));
            assumeThat(lastName, is(not(equalTo(null))));
            assumeThat(address1, is(not(equalTo(null))));

            assumeThat(address2, is(not(equalTo(null))));
            assumeThat(city, is(not(equalTo(null))));
            assumeThat(state, is(not(equalTo(null))));

            Employee e = new Employee(firstName, lastName, age, address1, address2, city, state, postalCode);
            assumeThat(e, is(not(equalTo(null))));

            assertAll("Validate Employee Properties",
                    () -> assertEquals(e.getFirstName(), firstName),
                    () -> assertEquals(e.getLastName(), lastName),
                    () -> assertEquals(e.getAge(), age),
                    () -> assertEquals(e.getAddress1(), address1),
                    () -> assertEquals(e.getAddress2(), address2),
                    () -> assertEquals(e.getCity(), city),
                    () -> assertEquals(e.getState(), state),
                    () -> assertEquals(e.getPostalCode(), postalCode)
            );

            assertEquals(e.addEmployee(), "Successfully Added Employee");
        }

        @Test
        void testMethod2()
        {
             Mockito.when(employee.addEmployee()).thenReturn("Employee was added");
             assertEquals("Employee was added", employee.addEmployee());
        }
}
